(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is GeckoSDK for Delphi.
 *
 * The Initial Developer of the Original Code is Takanori Ito.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** *)
unit nsConsts;

interface

const
{$IFDEF MSWINDOWS}
  XPCOM_DLL = 'xpcom.dll';
  XUL_DLL = 'xul.dll';
{$ENDIF}
{$IFDEF UNIX}
  XPCOM_DLL = 'libxpcom.so';
  XUL_DLL = 'libxul.so';
{$ENDIF}

const
  GRE_MOZILLA_WIN_REG_LOC = 'Software\mozilla.org\GRE\';
  GRE_FIREFOX_BASE_WIN_REG_LOC = 'SOFTWARE\Mozilla\Mozilla Firefox';

  // 1.7 Release
  MOZILLA_VERSION = 1.7;
  GRE_BUILD_ID = '1.7_2004061609';
  NS_BUILD_ID = 2004061609;

  // 1.7.1 Release
  //MOZILLA_VERSION = 1.7;
  //GRE_BUILD_ID = '1.7.1_2004070721';
  //NS_BUILD_ID = 2004070721;

  // 1.7.2 Release
  //MOZILLA_VERSION = 1.7;
  //GRE_BUILD_ID = '1.7.2_2004080302';
  //NS_BUILD_ID = 2004080302;

  // 1.7.3 Release
  //MOZILLA_VERSION = 1.7;
  //GRE_BUILD_ID = '1.7.3_2004091008';
  //NS_BUILD_ID = 2004091008;

  // 1.7.5 Release
  //MOZILLA_VERSION = 1.7;
  //GRE_BUILD_ID = '1.7.5_2004122323';
  //NS_BUILD_ID = 2004122323;

  // 1.7.6 Release
  //MOZILLA_VERSION = 1.7;
  //GRE_BUILD_ID = '1.7.6_2005031907';
  //NS_BUILD_ID = 2005031907;

  // 1.7.7 Release
  //MOZILLA_VERSION = 1.7;
  //GRE_BUILD_ID = '1.7.7_2005041417';
  //NS_BUILD_ID = 2005041417;

implementation

end.
